import java.util.*;
import javax.vecmath.*;
import java.awt.geom.*;

/**
 * Line segment in 3D space
 */
public class LineSegment {

    public static final double ALMOST_ZERO = 0.00001;

    private final Point3d _from;
    private final Point3d _to;

    public LineSegment(final Point3d from, final Point3d to) {
        _from = from;
        _to = to;
    }

    public void rotate(final double alpha, final double beta, final double gamma) {
        Matrix4d t1 = new Matrix4d();
        t1.rotX(Math.toRadians(alpha));
        Matrix4d t2 = new Matrix4d();
        t2.rotY(Math.toRadians(beta));
        Matrix4d t3 = new Matrix4d();
        t3.rotZ(Math.toRadians(gamma));

        t1.transform(_from);
        t2.transform(_from);
        t3.transform(_from);
        t1.transform(_to);
        t2.transform(_to);
        t3.transform(_to);
    }

    public void intersectXYPlane(final double h, ConvexHull hull) {
      // start point is (_from.x, _from.y, _from.z)
      // end point is (_to.x, _to.y, _to.z)
      // height of plane is h
      // an intersection point is created as new Point2d.Double(x,y)
      // all intersection points (0,1 or 2) are reported with hull.add(...)
    }
}
